-module(fib).

% Exports both functions, now both can be called as fib:main() and
% fib:fibonacci(X).
-export([main/0, fibonacci/1]).

%%% Just different ways to pattern match in Erlang
fibonacci(N) when N < 1 ->
    0;
fibonacci(1) ->
    1;
fibonacci(N) ->
    % implement directly
    % fibonacci(N-1)+fibonacci(N-2).
    % tailfib(N-1,1,0).
    % implement with messages wo references
    Me = self(),
    Ref1 = make_ref(),
    Ref2 = make_ref(),
    spawn(fun() ->
       Value = fibonacci(N-1),
       Me ! { Value, Ref1 }  end),
    spawn(fun() ->
       Value = fibonacci(N-2),
       Me ! { Value, Ref2 } end),
    receive
      {Val1, Ref1} when is_number(Val1) -> Val1
    end,
    receive
      {Val2, Ref2} when is_number(Val1) -> Val2
    end,
    Val1 + Val2.
    
    % implement with messages w references

tailfib(N,Current,_Prev) when N == 0 ->
     Current;
tailfib(N,Current,Prev) ->
     tailfib(N-1,Current+Prev,Current).
     
main() ->
    Ref1 = make_ref(),
    Ref2 = make_ref(),
    self() ! { 1, Ref1 },
    self() ! { 1, Ref2 },
    fibonacci(20).
