-module(server_fun).
-export([main/0]).

start_server() ->
    Pid = spawn(fun server_fun/0),
    catch unregister(server),
    register(server, Pid).

% Modified server. We now sends the function as part of the message.
server_fun() ->
    implementMe.


main() ->
    start_server(),

    % Note how we can create functions to send as an argument, and that we pass
    % the created function's arguments as a list ([10, 2]).
    % For addition, use fun(X, Y) -> X + Y end
    % For subtracting, use fun(X, Y) -> X - Y end
    server ! {compute, fun(X, Y) -> X * Y end, [10, 2], self()},
    receive
        Res ->
            io:fwrite("~p~n", [Res])
    end.
